////////////////////////////////////////////////////////////////////////////
//	Created		: 24.12.2009
//	Author		: Konstantin Slipchenko
//	Copyright (C) GSC Game World - 2009
////////////////////////////////////////////////////////////////////////////

#ifndef MAYA_ANIMATION_DATA_H_INCLUDED
#define MAYA_ANIMATION_DATA_H_INCLUDED

#include <xray/maya_animation/anim_track.h>

namespace xray {
namespace maya_animation {

class animation_data {

public:
			bool		load				( const char* fn );
			void		clear				( );
			void		bone_pose			( xray::float4x4 &pose, u32 id, float time );
			u32			anim_bone_count		( ){ return m_bone_animations.size(); }
			float		min_time			();
			float		max_time			();
			float		evaluate_mean_time	();
	inline	anim_track	&bone_animation		( u32 id ) { return m_bone_animations[id]; }

private:
	vector <anim_track>			m_bone_animations;

}; // class animation_data

} // namespace maya_animation
} // namespace xray

#endif // #ifndef MAYA_ANIMATION_DATA_H_INCLUDED