////////////////////////////////////////////////////////////////////////////
//	Created		: 25.03.2010
//	Author		: Armen Abroyan
//	Copyright (C) GSC Game World - 2010
////////////////////////////////////////////////////////////////////////////

#ifndef DX10_DEFINES_H_INCLUDED
#define DX10_DEFINES_H_INCLUDED

//#define D3DXGetImageInfoFromMemory D3DX10GetImageInfoFromMemory;\

#define	SHADER_PARAM_STUB	 

#define	D3DXGetImageInfoFromMemory				D3DX10GetImageInfoFromMemory
#define	D3DXCreateTextureFromMemory				D3DX10CreateTextureFromMemory
#define	D3DXCompileFromMemory					D3DX10CompileFromMemory

typedef	ID3D10VertexShader						ID3DVertexShader;
typedef	ID3D10GeometryShader					ID3DGeometryShader;
typedef	ID3D10PixelShader						ID3DPixelShader;
typedef	ID3D10Blob								ID3DBlob;
typedef	D3D10_SHADER_MACRO						D3D_SHADER_MACRO;
typedef	ID3D10Query								ID3DQuery;
typedef	D3D10_VIEWPORT							D3D_VIEWPORT;
typedef	ID3D10Include							ID3DInclude;
typedef	ID3D10Texture2D							ID3DTexture2D;
typedef	ID3D10RenderTargetView					ID3DRenderTargetView;
typedef	ID3D10DepthStencilView					ID3DDepthStencilView;
typedef	ID3D10Resource							ID3DBaseTexture;
typedef	D3D10_TEXTURE2D_DESC					D3D_TEXTURE2D_DESC;
typedef	D3D10_TEXTURE3D_DESC					D3D_TEXTURE3D_DESC;
typedef ID3D10Buffer							ID3DVertexBuffer;
typedef ID3D10Buffer							ID3DIndexBuffer;
typedef ID3D10Buffer							ID3DConstantBuffer;
typedef ID3D10Buffer							ID3DBuffer;
typedef	ID3D10Texture3D							ID3DTexture3D;
typedef	ID3D10SamplerState						ID3DSamplerState;
typedef	ID3D10Device							ID3DDevice;
typedef	ID3D10Device							ID3DDeviceContext;
typedef	ID3D10Device1							ID3DDevice1;
typedef	ID3D10ShaderResourceView				ID3DShaderResourceView;
typedef	ID3D10InputLayout						ID3DInputLayout;

// Render states defines
typedef	ID3D10RasterizerState					ID3DRasterizerState;
typedef	ID3D10DepthStencilState					ID3DDepthStencilState;
typedef	ID3D10BlendState						ID3DBlendState;

typedef	ID3D10ShaderReflection					ID3DShaderReflection;
typedef	ID3D10ShaderReflectionConstantBuffer	ID3DShaderReflectionConstantBuffer;
typedef	ID3D10ShaderReflectionVariable			ID3DShaderReflectionVariable;
typedef	ID3D10ShaderReflectionType				ID3DShaderReflectionType;

typedef	D3D10_RASTERIZER_DESC						D3D_RASTERIZER_DESC;
typedef	D3D10_DEPTH_STENCIL_DESC					D3D_DEPTH_STENCIL_DESC;
typedef	D3D10_BLEND_DESC							D3D_BLEND_DESC;
typedef D3D10_SAMPLER_DESC							D3D_SAMPLER_DESC;

typedef D3D10_SHADER_DESC							D3D_SHADER_DESC;

typedef	D3D10_INPUT_ELEMENT_DESC					D3D_INPUT_ELEMENT_DESC;
//typedef	D3D10_DRIVER_TYPE							D3D_DRIVER_TYPE;

//typedef	D3D10_SHADER_MACRO						D3D_SHADER_MACRO;

typedef	ID3DInclude									ID3D10Include;
#define D3D_INCLUDE_TYPE							D3D10_INCLUDE_TYPE

#define D3DX_IMAGE_INFO								D3DX10_IMAGE_INFO 
#define D3DX_IMAGE_LOAD_INFO						D3DX10_IMAGE_LOAD_INFO

#define	D3D_CREATE_DEVICE_DEBUG						D3D10_CREATE_DEVICE_DEBUG

#define D3D_SHADER_DEBUG							D3D10_SHADER_DEBUG
#define D3D_SHADER_PACK_MATRIX_ROW_MAJOR			D3D10_SHADER_PACK_MATRIX_ROW_MAJOR
#define D3D_SHADER_PACK_MATRIX_COLUMN_MAJOR			D3D10_SHADER_PACK_MATRIX_COLUMN_MAJOR
#define D3D_SHADER_PREFER_FLOW_CONTROL				D3D10_SHADER_PREFER_FLOW_CONTROL

#define D3D_CREATE_DEVICE_SINGLETHREADED							D3D10_CREATE_DEVICE_SINGLETHREADED
#define D3D_CREATE_DEVICE_DEBUG										D3D10_CREATE_DEVICE_DEBUG
#define D3D_CREATE_DEVICE_SWITCH_TO_REF								D3D10_CREATE_DEVICE_SWITCH_TO_REF
#define D3D_CREATE_DEVICE_PREVENT_INTERNAL_THREADING_OPTIMIZATIONS	D3D10_CREATE_DEVICE_PREVENT_INTERNAL_THREADING_OPTIMIZATIONS
#define D3D_CREATE_DEVICE_BGRA_SUPPORT								D3D10_CREATE_DEVICE_BGRA_SUPPORT

#define D3DPRESENT_INTERVAL_DEFAULT     			0x00000000L
#define D3DPRESENT_INTERVAL_ONE         			0x00000001L
#define D3DPRESENT_INTERVAL_TWO         			0x00000002L
#define D3DPRESENT_INTERVAL_THREE       			0x00000004L
#define D3DPRESENT_INTERVAL_FOUR        			0x00000008L
#define D3DPRESENT_INTERVAL_IMMEDIATE   			0x80000000L  // Not used in DX10

#define D3D_COMMONSHADER_SAMPLER_SLOT_COUNT				D3D10_COMMONSHADER_SAMPLER_SLOT_COUNT
#define D3D_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT		16 //D3D10_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT;


typedef D3D10_COLOR_WRITE_ENABLE					D3D_COLOR_WRITE_ENABLE;

#define	D3D_COLOR_WRITE_ENABLE_RED					D3D10_COLOR_WRITE_ENABLE_RED
#define	D3D_COLOR_WRITE_ENABLE_GREEN				D3D10_COLOR_WRITE_ENABLE_GREEN
#define	D3D_COLOR_WRITE_ENABLE_BLUE					D3D10_COLOR_WRITE_ENABLE_BLUE
#define	D3D_COLOR_WRITE_ENABLE_ALPHA				D3D10_COLOR_WRITE_ENABLE_ALPHA
#define	D3D_COLOR_WRITE_ENABLE_ALL					D3D10_COLOR_WRITE_ENABLE_ALL
#define	D3D_COLOR_WRITE_ENABLE_NONE					D3D_COLOR_WRITE_ENABLE(0)


typedef D3D10_COMPARISON_FUNC						D3D_COMPARISON_FUNC;

#define	D3D_COMPARISON_NEVER						D3D10_COMPARISON_NEVER
#define	D3D_COMPARISON_LESS							D3D10_COMPARISON_LESS
#define	D3D_COMPARISON_EQUAL						D3D10_COMPARISON_EQUAL
#define	D3D_COMPARISON_LESS_EQUAL					D3D10_COMPARISON_LESS_EQUAL
#define	D3D_COMPARISON_GREATER						D3D10_COMPARISON_GREATER
#define	D3D_COMPARISON_NOT_EQUAL					D3D10_COMPARISON_NOT_EQUAL
#define	D3D_COMPARISON_GREATER_EQUAL				D3D10_COMPARISON_GREATER_EQUAL
#define	D3D_COMPARISON_ALWAYS						D3D10_COMPARISON_ALWAYS


typedef D3D10_STENCIL_OP							D3D_STENCIL_OP;

#define	D3D_STENCIL_OP_KEEP							D3D10_STENCIL_OP_KEEP
#define	D3D_STENCIL_OP_ZERO							D3D10_STENCIL_OP_ZERO
#define	D3D_STENCIL_OP_REPLACE						D3D10_STENCIL_OP_REPLACE
#define	D3D_STENCIL_OP_INCR_SAT						D3D10_STENCIL_OP_INCR_SAT
#define	D3D_STENCIL_OP_DECR_SAT						D3D10_STENCIL_OP_DECR_SAT
#define	D3D_STENCIL_OP_INVERT						D3D10_STENCIL_OP_INVERT
#define	D3D_STENCIL_OP_INCR							D3D10_STENCIL_OP_INCR
#define	D3D_STENCIL_OP_DECR							D3D10_STENCIL_OP_DECR


typedef	D3D10_BLEND									D3D_BLEND;

#define D3D_BLEND_ZERO								D3D10_BLEND_ZERO
#define D3D_BLEND_ONE								D3D10_BLEND_ONE
#define D3D_BLEND_SRC_COLOR							D3D10_BLEND_SRC_COLOR
#define D3D_BLEND_INV_SRC_COLOR						D3D10_BLEND_INV_SRC_COLOR	
#define D3D_BLEND_SRC_ALPHA							D3D10_BLEND_SRC_ALPHA	
#define D3D_BLEND_INV_SRC_ALPHA						D3D10_BLEND_INV_SRC_ALPHA	
#define D3D_BLEND_DEST_ALPHA						D3D10_BLEND_DEST_ALPHA	
#define D3D_BLEND_INV_DEST_ALPHA					D3D10_BLEND_INV_DEST_ALPHA	
#define D3D_BLEND_DEST_COLOR						D3D10_BLEND_DEST_COLOR	
#define D3D_BLEND_INV_DEST_COLOR					D3D10_BLEND_INV_DEST_COLOR	
#define D3D_BLEND_SRC_ALPHA_SAT						D3D10_BLEND_SRC_ALPHA_SAT	
#define D3D_BLEND_BLEND_FACTOR						D3D10_BLEND_BLEND_FACTOR	
#define D3D_BLEND_INV_BLEND_FACTOR					D3D10_BLEND_INV_BLEND_FACTOR	
#define D3D_BLEND_SRC1_COLOR						D3D10_BLEND_SRC1_COLOR	
#define D3D_BLEND_INV_SRC1_COLOR					D3D10_BLEND_INV_SRC1_COLOR	
#define D3D_BLEND_SRC1_ALPHA						D3D10_BLEND_SRC1_ALPHA	
#define D3D_BLEND_INV_SRC1_ALPHA					D3D10_BLEND_INV_SRC1_ALPHA	


typedef	D3D10_TEXTURE_ADDRESS_MODE					D3D_TEXTURE_ADDRESS_MODE;

#define	D3D_TEXTURE_ADDRESS_WRAP					D3D10_TEXTURE_ADDRESS_WRAP
#define	D3D_TEXTURE_ADDRESS_MIRROR					D3D10_TEXTURE_ADDRESS_MIRROR
#define	D3D_TEXTURE_ADDRESS_CLAMP					D3D10_TEXTURE_ADDRESS_CLAMP
#define	D3D_TEXTURE_ADDRESS_BORDER					D3D10_TEXTURE_ADDRESS_BORDER
#define	D3D_TEXTURE_ADDRESS_MIRROR_ONCE				D3D10_TEXTURE_ADDRESS_MIRROR_ONCE


typedef D3D10_FILTER		D3D_FILTER;

#define	D3D_FILTER_MIN_MAG_MIP_POINT							D3D10_FILTER_MIN_MAG_MIP_POINT
#define	D3D_FILTER_MIN_MAG_POINT_MIP_LINEAR						D3D10_FILTER_MIN_MAG_POINT_MIP_LINEAR
#define	D3D_FILTER_MIN_POINT_MAG_LINEAR_MIP_POINT				D3D10_FILTER_MIN_POINT_MAG_LINEAR_MIP_POINT
#define	D3D_FILTER_MIN_POINT_MAG_MIP_LINEAR						D3D10_FILTER_MIN_POINT_MAG_MIP_LINEAR
#define	D3D_FILTER_MIN_LINEAR_MAG_MIP_POINT						D3D10_FILTER_MIN_LINEAR_MAG_MIP_POINT 
#define	D3D_FILTER_MIN_LINEAR_MAG_POINT_MIP_LINEAR				D3D10_FILTER_MIN_LINEAR_MAG_POINT_MIP_LINEAR
#define	D3D_FILTER_MIN_MAG_LINEAR_MIP_POINT						D3D10_FILTER_MIN_MAG_LINEAR_MIP_POINT 
#define	D3D_FILTER_MIN_MAG_MIP_LINEAR							D3D10_FILTER_MIN_MAG_MIP_LINEAR
#define	D3D_FILTER_ANISOTROPIC									D3D10_FILTER_ANISOTROPIC
#define	D3D_FILTER_COMPARISON_MIN_MAG_MIP_POINT					D3D10_FILTER_COMPARISON_MIN_MAG_MIP_POINT
#define	D3D_FILTER_COMPARISON_MIN_MAG_POINT_MIP_LINEAR			D3D10_FILTER_COMPARISON_MIN_MAG_POINT_MIP_LINEAR
#define	D3D_FILTER_COMPARISON_MIN_POINT_MAG_LINEAR_MIP_POINT	D3D10_FILTER_COMPARISON_MIN_POINT_MAG_LINEAR_MIP_POINT
#define	D3D_FILTER_COMPARISON_MIN_POINT_MAG_MIP_LINEAR			D3D10_FILTER_COMPARISON_MIN_POINT_MAG_MIP_LINEAR
#define	D3D_FILTER_COMPARISON_MIN_LINEAR_MAG_MIP_POINT			D3D10_FILTER_COMPARISON_MIN_LINEAR_MAG_MIP_POINT
#define	D3D_FILTER_COMPARISON_MIN_LINEAR_MAG_POINT_MIP_LINEAR 	D3D10_FILTER_COMPARISON_MIN_LINEAR_MAG_POINT_MIP_LINEAR
#define	D3D_FILTER_COMPARISON_MIN_MAG_LINEAR_MIP_POINT			D3D10_FILTER_COMPARISON_MIN_MAG_LINEAR_MIP_POINT
#define	D3D_FILTER_COMPARISON_MIN_MAG_MIP_LINEAR				D3D10_FILTER_COMPARISON_MIN_MAG_MIP_LINEAR
#define	D3D_FILTER_COMPARISON_ANISOTROPIC						D3D10_FILTER_COMPARISON_ANISOTROPIC
#define	D3D_FILTER_TEXT_1BIT									D3D10_FILTER_TEXT_1BIT

typedef	D3D10_BUFFER_DESC							D3D_BUFFER_DESC;
typedef	D3D10_SUBRESOURCE_DATA						D3D_SUBRESOURCE_DATA;
typedef D3D10_USAGE									D3D_USAGE;
#define	D3D_USAGE_DEFAULT							D3D10_USAGE_DEFAULT
#define	D3D_USAGE_DYNAMIC							D3D10_USAGE_DYNAMIC
#define	D3D_USAGE_STAGING							D3D10_USAGE_STAGING
#define	D3D_USAGE_IMMUTABLE							D3D10_USAGE_IMMUTABLE

typedef D3D10_BIND_FLAG									D3D_BIND_FLAG;
#define	D3D_BIND_VERTEX_BUFFER						D3D10_BIND_VERTEX_BUFFER
#define	D3D_BIND_INDEX_BUFFER						D3D10_BIND_INDEX_BUFFER
#define	D3D_BIND_CONSTANT_BUFFER					D3D10_BIND_CONSTANT_BUFFER 
#define	D3D_BIND_SHADER_RESOURCE					D3D10_BIND_SHADER_RESOURCE
#define	D3D_BIND_STREAM_OUTPUT						D3D10_BIND_STREAM_OUTPUT 
#define	D3D_BIND_RENDER_TARGET						D3D10_BIND_RENDER_TARGET 
#define	D3D_BIND_DEPTH_STENCIL						D3D10_BIND_DEPTH_STENCIL

typedef D3D10_CPU_ACCESS_FLAG						D3D_CPU_ACCESS_FLAG;
#define	D3D_CPU_ACCESS_WRITE						D3D10_CPU_ACCESS_WRITE 
#define	D3D_CPU_ACCESS_READ							D3D10_CPU_ACCESS_READ 

#define	D3D_STENCIL_OP_KEEP							D3D10_STENCIL_OP_KEEP
#define	D3D_STENCIL_OP_ZERO							D3D10_STENCIL_OP_ZERO
#define	D3D_STENCIL_OP_REPLACE						D3D10_STENCIL_OP_REPLACE
#define	D3D_STENCIL_OP_INCR_SAT						D3D10_STENCIL_OP_INCR_SAT
#define	D3D_STENCIL_OP_DECR_SAT						D3D10_STENCIL_OP_DECR_SAT
#define	D3D_STENCIL_OP_INVERT						D3D10_STENCIL_OP_INVERT
#define	D3D_STENCIL_OP_INCR							D3D10_STENCIL_OP_INCR
#define	D3D_STENCIL_OP_DECR							D3D10_STENCIL_OP_DECR

#define	D3D_BLEND_ZERO								D3D10_BLEND_ZERO
#define	D3D_BLEND_ONE								D3D10_BLEND_ONE
#define	D3D_BLEND_SRC_COLOR							D3D10_BLEND_SRC_COLOR
#define	D3D_BLEND_INV_SRC_COLOR						D3D10_BLEND_INV_SRC_COLOR
#define	D3D_BLEND_SRC_ALPHA							D3D10_BLEND_SRC_ALPHA
#define	D3D_BLEND_INV_SRC_ALPHA						D3D10_BLEND_INV_SRC_ALPHA
#define	D3D_BLEND_DEST_ALPHA						D3D10_BLEND_DEST_ALPHA
#define	D3D_BLEND_INV_DEST_ALPHA					D3D10_BLEND_INV_DEST_ALPHA
#define	D3D_BLEND_DEST_COLOR						D3D10_BLEND_DEST_COLOR
#define	D3D_BLEND_INV_DEST_COLOR					D3D10_BLEND_INV_DEST_COLOR
#define	D3D_BLEND_SRC_ALPHA_SAT						D3D10_BLEND_SRC_ALPHA_SAT
#define	D3D_BLEND_BLEND_FACTOR						D3D10_BLEND_BLEND_FACTOR
#define	D3D_BLEND_INV_BLEND_FACTOR					D3D10_BLEND_INV_BLEND_FACTOR
#define	D3D_BLEND_SRC1_COLOR						D3D10_BLEND_SRC1_COLOR
#define	D3D_BLEND_INV_SRC1_COLOR					D3D10_BLEND_INV_SRC1_COLOR
#define	D3D_BLEND_SRC1_ALPHA						D3D10_BLEND_SRC1_ALPHA
#define	D3D_BLEND_INV_SRC1_ALPHA					D3D10_BLEND_INV_SRC1_ALPHA


typedef D3D10_FORMAT_SUPPORT	D3D_FORMAT_SUPPORT;
#define	D3D10_FORMAT_SUPPORT_BUFFER							D3D10_FORMAT_SUPPORT_BUFFER
#define	D3D10_FORMAT_SUPPORT_IA_VERTEX_BUFFER				D3D10_FORMAT_SUPPORT_IA_VERTEX_BUFFER
#define	D3D10_FORMAT_SUPPORT_IA_INDEX_BUFFER				D3D10_FORMAT_SUPPORT_IA_INDEX_BUFFER 
#define	D3D10_FORMAT_SUPPORT_SO_BUFFER						D3D10_FORMAT_SUPPORT_SO_BUFFER 
#define	D3D10_FORMAT_SUPPORT_TEXTURE1D						D3D10_FORMAT_SUPPORT_TEXTURE1D 
#define	D3D10_FORMAT_SUPPORT_TEXTURE2D						D3D10_FORMAT_SUPPORT_TEXTURE2D 
#define	D3D10_FORMAT_SUPPORT_TEXTURE3D						D3D10_FORMAT_SUPPORT_TEXTURE3D 
#define	D3D10_FORMAT_SUPPORT_TEXTURECUBE					D3D10_FORMAT_SUPPORT_TEXTURECUBE
#define	D3D10_FORMAT_SUPPORT_SHADER_LOAD					D3D10_FORMAT_SUPPORT_SHADER_LOAD
#define	D3D10_FORMAT_SUPPORT_SHADER_SAMPLE					D3D10_FORMAT_SUPPORT_SHADER_SAMPLE
#define	D3D10_FORMAT_SUPPORT_SHADER_SAMPLE_COMPARISON		D3D10_FORMAT_SUPPORT_SHADER_SAMPLE_COMPARISON
#define	D3D10_FORMAT_SUPPORT_SHADER_SAMPLE_MONO_TEXT		D3D10_FORMAT_SUPPORT_SHADER_SAMPLE_MONO_TEXT
#define	D3D10_FORMAT_SUPPORT_MIP							D3D10_FORMAT_SUPPORT_MIP
#define	D3D10_FORMAT_SUPPORT_MIP_AUTOGEN					D3D10_FORMAT_SUPPORT_MIP_AUTOGEN 
#define	D3D10_FORMAT_SUPPORT_RENDER_TARGET					D3D10_FORMAT_SUPPORT_RENDER_TARGET 
#define	D3D10_FORMAT_SUPPORT_BLENDABLE						D3D10_FORMAT_SUPPORT_BLENDABLE 
#define	D3D10_FORMAT_SUPPORT_DEPTH_STENCIL					D3D10_FORMAT_SUPPORT_DEPTH_STENCIL 
#define	D3D10_FORMAT_SUPPORT_CPU_LOCKABLE					D3D10_FORMAT_SUPPORT_CPU_LOCKABLE 
#define	D3D10_FORMAT_SUPPORT_MULTISAMPLE_RESOLVE			D3D10_FORMAT_SUPPORT_MULTISAMPLE_RESOLVE 
#define	D3D10_FORMAT_SUPPORT_DISPLAY						D3D10_FORMAT_SUPPORT_DISPLAY 
#define	D3D10_FORMAT_SUPPORT_CAST_WITHIN_BIT_LAYOUT			D3D10_FORMAT_SUPPORT_CAST_WITHIN_BIT_LAYOUT 
#define	D3D10_FORMAT_SUPPORT_MULTISAMPLE_RENDERTARGET		D3D10_FORMAT_SUPPORT_MULTISAMPLE_RENDERTARGET 
#define	D3D10_FORMAT_SUPPORT_MULTISAMPLE_LOAD				D3D10_FORMAT_SUPPORT_MULTISAMPLE_LOAD 
#define	D3D10_FORMAT_SUPPORT_SHADER_GATHER					D3D10_FORMAT_SUPPORT_SHADER_GATHER 


typedef D3D10_FILL_MODE					D3D_FILL_MODE;
#define	D3D_FILL_WIREFRAME				D3D10_FILL_WIREFRAME
#define	D3D_FILL_SOLID					D3D10_FILL_SOLID


typedef D3D10_CULL_MODE					D3D_CULL_MODE;
#define	D3D_CULL_NONE					D3D10_CULL_NONE 
#define	D3D_CULL_FRONT					D3D10_CULL_FRONT
#define	D3D_CULL_BACK					D3D10_CULL_BACK 


typedef D3D10_DEPTH_WRITE_MASK			D3D_DEPTH_WRITE_MASK;
#define	D3D_DEPTH_WRITE_MASK_ZERO		D3D10_DEPTH_WRITE_MASK_ZERO
#define	D3D_DEPTH_WRITE_MASK_ALL		D3D10_DEPTH_WRITE_MASK_ALL 


typedef D3D10_BLEND_OP					D3D_BLEND_OP;
#define	D3D_BLEND_OP_ADD				D3D10_BLEND_OP_ADD 
#define	D3D_BLEND_OP_SUBTRACT			D3D10_BLEND_OP_SUBTRACT 
#define	D3D_BLEND_OP_REV_SUBTRACT		D3D10_BLEND_OP_REV_SUBTRACT 
#define	D3D_BLEND_OP_MIN				D3D10_BLEND_OP_MIN 
#define	D3D_BLEND_OP_MAX				D3D10_BLEND_OP_MAX 

typedef D3D10_CBUFFER_TYPE				D3D_CBUFFER_TYPE;
#define	D3D_CT_CBUFFER					D3D10_CT_CBUFFER;
#define	D3D_CT_TBUFFER					D3D10_CT_CBUFFER;

typedef	D3D10_SHADER_TYPE_DESC			D3D_SHADER_TYPE_DESC;
typedef	D3D10_SHADER_BUFFER_DESC		D3D_SHADER_BUFFER_DESC;
typedef	D3D10_SHADER_VARIABLE_DESC		D3D_SHADER_VARIABLE_DESC;
typedef	D3D10_SHADER_INPUT_BIND_DESC	D3D_SHADER_INPUT_BIND_DESC;

typedef D3D10_MAP						D3D_MAP;
#define	D3D_MAP_READ					D3D10_MAP_READ 
#define	D3D_MAP_WRITE					D3D10_MAP_WRITE
#define	D3D_MAP_READ_WRITE				D3D10_MAP_READ_WRITE 
#define	D3D_MAP_WRITE_DISCARD			D3D10_MAP_WRITE_DISCARD 
#define	D3D_MAP_WRITE_NO_OVERWRITE		D3D10_MAP_WRITE_NO_OVERWRITE 


typedef D3D10_SHADER_INPUT_TYPE						D3D_SHADER_INPUT_TYPE;
#define	D3D10_SIT_CBUFFER							D3D10_SIT_CBUFFER
#define	D3D10_SIT_TBUFFER							D3D10_SIT_TBUFFER
#define	D3D10_SIT_TEXTURE							D3D10_SIT_TEXTURE
#define	D3D10_SIT_SAMPLER							D3D10_SIT_SAMPLER
#define	D3D11_SIT_UAV_RWTYPED						D3D11_SIT_UAV_RWTYPED
#define	D3D11_SIT_STRUCTURED						D3D11_SIT_STRUCTURED
#define	D3D11_SIT_UAV_RWSTRUCTURED					D3D11_SIT_UAV_RWSTRUCTURED
#define	D3D11_SIT_BYTEADDRESS						D3D11_SIT_BYTEADDRESS
#define	D3D11_SIT_UAV_RWBYTEADDRESS					D3D11_SIT_UAV_RWBYTEADDRESS
#define	D3D11_SIT_UAV_APPEND_STRUCTURED				D3D11_SIT_UAV_APPEND_STRUCTURED
#define	D3D11_SIT_UAV_CONSUME_STRUCTURED			D3D11_SIT_UAV_CONSUME_STRUCTURED
#define	D3D11_SIT_UAV_RWSTRUCTURED_WITH_COUNTER		D3D11_SIT_UAV_RWSTRUCTURED_WITH_COUNTER

typedef D3D10_SHADER_RESOURCE_VIEW_DESC			D3D_SHADER_RESOURCE_VIEW_DESC;
typedef D3D10_DEPTH_STENCIL_VIEW_DESC			D3D_DEPTH_STENCIL_VIEW_DESC;

typedef D3D10_RESOURCE_DIMENSION				D3D_RESOURCE_DIMENSION;
#define D3D_RESOURCE_DIMENSION_UNKNOWN			D3D10_RESOURCE_DIMENSION_UNKNOWN
#define D3D_RESOURCE_DIMENSION_BUFFER			D3D10_RESOURCE_DIMENSION_BUFFER
#define D3D_RESOURCE_DIMENSION_TEXTURE1D		D3D10_RESOURCE_DIMENSION_TEXTURE1D
#define D3D_RESOURCE_DIMENSION_TEXTURE2D		D3D10_RESOURCE_DIMENSION_TEXTURE2D
#define D3D_RESOURCE_DIMENSION_TEXTURE3D		D3D10_RESOURCE_DIMENSION_TEXTURE3D


typedef D3D10_RESOURCE_MISC_FLAG				D3D_RESOURCE_MISC_FLAG;
#define D3D_RESOURCE_MISC_GENERATE_MIPS			D3D10_RESOURCE_MISC_GENERATE_MIPS
#define D3D_RESOURCE_MISC_SHARED				D3D10_RESOURCE_MISC_SHARED
#define D3D_RESOURCE_MISC_TEXTURECUBE			D3D10_RESOURCE_MISC_TEXTURECUBE
#define D3D_RESOURCE_MISC_SHARED_KEYEDMUTEX		D3D10_RESOURCE_MISC_SHARED_KEYEDMUTEX
#define D3D_RESOURCE_MISC_GDI_COMPATIBLE		D3D10_RESOURCE_MISC_GDI_COMPATIBLE

typedef D3D10_SRV_DIMENSION						D3D_SRV_DIMENSION;
#define D3D_SRV_DIMENSION_UNKNOWN				D3D10_SRV_DIMENSION_UNKNOWN
#define D3D_SRV_DIMENSION_BUFFER				D3D10_SRV_DIMENSION_BUFFER
#define D3D_SRV_DIMENSION_TEXTURE1D				D3D10_SRV_DIMENSION_TEXTURE1D
#define D3D_SRV_DIMENSION_TEXTURE1DARRAY		D3D10_SRV_DIMENSION_TEXTURE1DARRAY
#define D3D_SRV_DIMENSION_TEXTURE2D				D3D10_SRV_DIMENSION_TEXTURE2D
#define D3D_SRV_DIMENSION_TEXTURE2DARRAY		D3D10_SRV_DIMENSION_TEXTURE2DARRAY	
#define D3D_SRV_DIMENSION_TEXTURE2DMS			D3D10_SRV_DIMENSION_TEXTURE2DMS	
#define D3D_SRV_DIMENSION_TEXTURE2DMSARRAY		D3D10_SRV_DIMENSION_TEXTURE2DMSARRAY
#define D3D_SRV_DIMENSION_TEXTURE3D				D3D10_SRV_DIMENSION_TEXTURE3D
#define D3D_SRV_DIMENSION_TEXTURECUBE			D3D10_SRV_DIMENSION_TEXTURECUBE

#define	D3D_REQ_TEXTURE2D_U_OR_V_DIMENSION		D3D10_REQ_TEXTURE2D_U_OR_V_DIMENSION

typedef D3D10_DSV_DIMENSION						D3D_DSV_DIMENSION;
#define D3D_DSV_DIMENSION_UNKNOWN				D3D10_DSV_DIMENSION_UNKNOWN	        
#define D3D_DSV_DIMENSION_TEXTURE1D				D3D10_DSV_DIMENSION_TEXTURE1D
#define D3D_DSV_DIMENSION_TEXTURE1DARRAY		D3D10_DSV_DIMENSION_TEXTURE1DARRAY
#define D3D_DSV_DIMENSION_TEXTURE2D				D3D10_DSV_DIMENSION_TEXTURE2D	
#define D3D_DSV_DIMENSION_TEXTURE2DARRAY		D3D10_DSV_DIMENSION_TEXTURE2DARRAY	
#define D3D_DSV_DIMENSION_TEXTURE2DMS			D3D10_DSV_DIMENSION_TEXTURE2DMS	
#define D3D_DSV_DIMENSION_TEXTURE2DMSARRAY		D3D10_DSV_DIMENSION_TEXTURE2DMSARRAY


typedef D3D10_INPUT_CLASSIFICATION				D3D_INPUT_CLASSIFICATION;

#define D3D_INPUT_PER_VERTEX_DATA				D3D10_INPUT_PER_VERTEX_DATA
#define D3D_INPUT_PER_INSTANCE_DATA				D3D10_INPUT_PER_VERTEX_DATA

typedef D3D10_PRIMITIVE_TOPOLOGY					D3D_PRIMITIVE_TOPOLOGY;
#define D3D_PRIMITIVE_TOPOLOGY_UNDEFINED			D3D10_PRIMITIVE_TOPOLOGY_UNDEFINED		
#define D3D_PRIMITIVE_TOPOLOGY_POINTLIST			D3D10_PRIMITIVE_TOPOLOGY_POINTLIST		
#define D3D_PRIMITIVE_TOPOLOGY_LINELIST			D3D10_PRIMITIVE_TOPOLOGY_LINELIST		
#define D3D_PRIMITIVE_TOPOLOGY_LINESTRIP			D3D10_PRIMITIVE_TOPOLOGY_LINESTRIP		
#define D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST		D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST	
#define D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP		D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP	
#define D3D_PRIMITIVE_TOPOLOGY_LINELIST_ADJ		D3D10_PRIMITIVE_TOPOLOGY_LINELIST_ADJ 
#define D3D_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ		D3D10_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ 
#define D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ	D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ
#define D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ	D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ


typedef D3D10_CLEAR_FLAG					D3D_CLEAR_FLAG;

#define D3D_CLEAR_DEPTH						D3D10_CLEAR_DEPTH
#define D3D_CLEAR_STENCIL					D3D10_CLEAR_STENCIL

typedef D3D10_BOX							D3D_BOX;



#endif // #ifndef DX10_DEFINES_H_INCLUDED
